#include "ListaSimples.h"
 
char ListaSimplesVazia(ListaSimples *inicio)
{
  if (inicio == NULL) 
    return(1);
  else
    return(0);
}

void ImprimeListaSimples(ListaSimples *inicio)
{
  while (inicio != NULL) {
    printf("%d --> ",inicio->elem);
    inicio = inicio->prox;
  }
  printf("\n");
}

char BuscaElementoListaSimples(ListaSimples *inicio, int elem, NoListaSimples **pos, NoListaSimples **ant)
{
  *pos = inicio;
  *ant = NULL;

  while (((*pos) != NULL)&&((*pos)->elem != elem)){ /* busca o elemento */
    (*ant) = (*pos);
    (*pos) = (*pos)->prox;
  }
  if ((*pos) != NULL){ /* achou */
    return(1);
  } 

  return(0);
}

char BuscaUltimoElementoListaSimples(ListaSimples *inicio, NoListaSimples **pos, NoListaSimples **ant){
  *pos = inicio;
  *ant = NULL;

  if (ListaSimplesVazia(inicio))
    return(0);

  while (((*pos)->prox != NULL)){ /* busca o ultimo elemento */
    (*ant) = (*pos);
    (*pos) = (*pos)->prox;
  }

  return(1);
}

NoListaSimples *CriaNoSimples(int elem)
{
  NoListaSimples *p = (NoListaSimples *)calloc(1,sizeof(NoListaSimples));
  p->elem = elem;
  p->prox = NULL;
  return(p);
}

void InsereInicioListaSimples(ListaSimples **inicio, int elem)
{
  NoListaSimples *p = CriaNoSimples(elem);

  p->prox = *inicio;
  *inicio =  p;
 
}

void InsereFimListaSimples(ListaSimples **inicio, int elem)
{
  NoListaSimples *p = CriaNoSimples(elem);
  NoListaSimples *pos, *ant;

  if (BuscaUltimoElementoListaSimples(*inicio,&pos,&ant)){
    pos->prox = p;
  } else { /* lista vazia */
    *inicio = p;
  }
}

char InsereElementoAntesDaChaveListaSimples(ListaSimples **inicio, int elem, int chave)
{
  NoListaSimples *pos, *ant;

  if(BuscaElementoListaSimples(*inicio, chave, &pos, &ant)){
    if (ant == NULL) { /* chave esta no inicio */
      InsereInicioListaSimples(inicio, elem);
    } else {
      InsereInicioListaSimples(&pos, elem);
      ant->prox = pos;
    }
    return(1);
  }
  
  return(0);
}

char  RemoveInicioListaSimples(ListaSimples **inicio, int *elem)
{
  NoListaSimples *p = *inicio;

  if (!ListaSimplesVazia(*inicio)){
    (*elem)   = (*inicio)->elem;
    (*inicio) = (*inicio)->prox; 
    free(p);
    return(1);
  }
 
  return(0);
}

char RemoveElementoListaSimples(ListaSimples **inicio, int elem)
{
  NoListaSimples *pos, *ant;

  if (BuscaElementoListaSimples(*inicio,elem,&pos,&ant)){ 
   RemoveInicioListaSimples(&pos,&elem);
    if (ant == NULL) 
      (*inicio) = pos;
    else
      ant->prox = pos;
    return(1);
  }
  
  return(0);
}

char  RemoveFimListaSimples(ListaSimples **inicio, int *elem)
{
  NoListaSimples *pos, *ant;

  if (BuscaUltimoElementoListaSimples(*inicio,&pos,&ant)){
    *elem = pos->elem;
    if (ant == NULL)
      (*inicio) = NULL;
    else
      ant->prox = pos->prox;
    free(pos);
    return(1);
  }

  return(0);
}

void DestroiListaSimples(ListaSimples **inicio)
{
  int elem;

  while (!ListaSimplesVazia(*inicio))
    RemoveInicioListaSimples(inicio,&elem);
}
